/*
Название: Сенсорная Прокрутка (Touch Scroll)
Автор: DK (Денис Кузнецов) (http://vk.com/id8137201)
Группа ВК: http://vk.com/rpgmakervxaceandmv
Сайт: http://dk-plugins.ru/
Версия: 1.0
Релиз: 03.03.2016
Первый релиз: 03.03.2016
*/

/*:
 * @plugindesc v.1.0 Добавляет сенсорную прокрутку содержимого
 * @author DK (Денис Кузнецов)
 * @help
 
 ### Информация о плагине ###
 Название: DK_Touch_Scroll
 Автор: DK
 Группа ВК: http://vk.com/rpgmakervxaceandmv
 Сайт: http://dk-plugins.ru/
 Версия: 1.0
 Релиз: 03.03.2016
 Первый релиз: 03.03.2016
 
 ### Лицензия и правила использования плагина ###
 Вы можете:
 -Бесплатно использовать данный плагин в некоммерческих и коммерческих проектах
 -Переводить плагин на другие языки (пожалуйста, сообщите, если Вы перевели плагин на другой язык)
 
 Вы не можете:
 -Убирать или изменять любую информацию о плагине (Название, авторство, контактная информация, версия и дата релиза)
 -Изменять код плагина вне поля "Настройки плагина" и "Конец настройки плагина" (если нашли ошибку, напишите мне о ней)
 
 * @param Расстояние прокрутки
 * @desc Расстояние, на которое нужно передвинуть палец, чтобы прокрутить содержимое. Стандартно: 150
 * @default 150
 
*/

var Imported = Imported || {};
Imported.DK_Touch_Scroll = true;

var DKVersion = DKVersion || {};
DKVersion.DK_Touch_Scroll = 1.0;

var Touch_Scroll_Y = 0;
var Touch_Scroll_Distance = Number(PluginManager.parameters('DKCore_Game_Time')['Расстояние прокрутки']) || 150;

TouchInput._onTouchStart = function(event) {
    for (var i = 0; i < event.changedTouches.length; i++) {
        var touch = event.changedTouches[i];
        var x = Graphics.pageToCanvasX(touch.pageX);
        var y = Graphics.pageToCanvasY(touch.pageY);
        if (Graphics.isInsideCanvas(x, y)) {
            this._screenPressed = true;
            this._pressedTime = 0;
			Touch_Scroll_Y = y;
            if (event.touches.length >= 2) {
                this._onCancel(x, y);
            } else {
                this._onTrigger(x, y);
            }
            event.preventDefault();
        }
    }
    if (window.cordova || window.navigator.standalone) {
        event.preventDefault();
    }
};

TouchInput._onTouchMove = function(event) {
    for (var i = 0; i < event.changedTouches.length; i++) {
        var touch = event.changedTouches[i];
        var x = Graphics.pageToCanvasX(touch.pageX);
        var y = Graphics.pageToCanvasY(touch.pageY);
        this._onMove(x, y);
		if (Graphics.isInsideCanvas(x, y)) {
			if (Touch_Scroll_Y > y + Touch_Scroll_Distance)
			{
				this._events.wheelY += 20;
				Touch_Scroll_Y = y;
			}
			else if (Touch_Scroll_Y < y - Touch_Scroll_Distance)
			{
				this._events.wheelY -= 20;
				Touch_Scroll_Y = y;
			}
		}
    }
};